// ==UserScript==
// @name CdC
// @description Petits outils pour la Couronne de Cuivre
// @include http://www.baldursgateworld.fr/*
// @grant GM_deleteValue
// @grant GM_setValue
// @grant GM_getValue
// ==/UserScript==

(function() {
	var form = document.getElementById("navbar_loginform");
	if (form == undefined) return; // On est déjà loggé.
	var user = document.getElementById("navbar_username");
	var pass = document.getElementById("navbar_password");
	
	var div = document.createElement("div");
	div.style.backgroundColor = "#484848";
	document.body.appendChild(div);
	div.style.position = "fixed";
	div.style.opacity = "0.5";
	div.style.zIndex = "998";
	div.style.bottom = "0";
	div.style.right = "0";
	div.style.left = "0";
	div.style.top = "0";
	
	var list = document.createElement("ul");
	list.style.backgroundColor = "ActiveCaption";
	list.style.border = "2px ridge ActiveBorder";
	document.body.appendChild(list);
	list.style.position = "fixed";
	list.style.overflow = "auto";
	list.style.zIndex = "999";
	list.style.bottom = "25%";
	list.style.right = "25%";
	list.style.left = "25%";
	list.style.top = "25%";
	
	var item = document.createElement("li");
	item.appendChild(document.createTextNode("Compte à utiliser :"));
	item.style.color = "CaptionText";
	item.style.fontSize = "1.2em";
	list.appendChild(item);
	
	var close = document.createElement("button");
	close.appendChild(document.createTextNode("✗"));
	close.style.cssFloat = "right";
	item.appendChild(close);
	close.onclick = function() {
		document.body.removeChild(list);
		document.body.removeChild(div);
	}
	
	var logins = GM_getValue("logins");
	if (logins == undefined) logins = new Array();
	else logins = logins.split(";");
	for (var i=0; i<logins.length; i++) {
		item = document.createElement("li");
		item.appendChild(document.createTextNode(logins[i]));
		item.onmouseover = function(ev) {
			ev.target.style.color = "HighlightText";
			ev.target.style.backgroundColor = "Highlight";
		}
		item.onmouseout = function(ev) {
			ev.target.style.color = "CaptionText";
			ev.target.style.backgroundColor = "transparent";
		}
		item.onclick = function(ev) {
			user.value = ev.target.firstChild.nodeValue;
			pass.value = GM_getValue(user.value);
			form.submit();
		}
		item.style.color = "CaptionText";
		item.style.borderRadius = "5px";
		item.style.cursor = "pointer";
		item.style.padding = "0.2em";
		list.appendChild(item);
	}
	
	item = document.createElement("li");
	list.appendChild(item);
	item.style.color = "CaptionText";
	item.appendChild(document.createTextNode("Nouveau : "));
	var adduser = document.createElement("input");
	adduser.type = "text";
	item.appendChild(adduser);
	var addpass = document.createElement("input");
	addpass.type = "password";
	item.appendChild(addpass);
	var add = document.createElement("button");
	add.appendChild(document.createTextNode("✔"));
	item.appendChild(add);
	add.onclick = function() {
		if (addpass.value == "") {
			var dump = "";
			for (var i=0; i<logins.length; i++)
				if (logins[i] == adduser.value)
					list.removeChild(list.childNodes[i+1]);
				else dump += ";"+logins[i];
			GM_setValue("logins", dump.substr(1));
			GM_deleteValue(adduser.value);
		} else {
			var dump = "";
			for (var i=0; i<logins.length; i++)
				if (logins[i] != adduser.value)
					dump += logins[i]+";";
			GM_setValue("logins", dump+adduser.value);
			GM_setValue(adduser.value, addpass.value);
			user.value = adduser.value;
			pass.value = addpass.value;
			form.submit();
		}
	}
})()
